package be.sisyphe.android;

import java.util.Calendar;

import android.app.Activity;
import android.app.AlarmManager;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.support.v4.app.NotificationCompat;
import com.unity3d.player.UnityPlayer;
import com.unity3d.player.UnityPlayerNativeActivity;

public class UnityNotification extends BroadcastReceiver {
		
	public static void sendNotification( String title, String text, int secondsFromNow ) {

		Calendar calendar = Calendar.getInstance();
		calendar.add( Calendar.SECOND, secondsFromNow );
        Activity activity = UnityPlayer.currentActivity;
        AlarmManager alarmManager = ( AlarmManager ) activity.getSystemService( Context.ALARM_SERVICE );
        Intent intent = new Intent( activity, UnityNotification.class );
        intent.putExtra( "title", title );
        intent.putExtra( "text", text );
        alarmManager.set( AlarmManager.RTC_WAKEUP, calendar.getTimeInMillis( ), PendingIntent.getBroadcast( activity, 0, intent, 0 ) );
	}
	
	public static void destroyNotification( Activity activity ) {
		NotificationManager notificationManager = ( NotificationManager ) activity.getApplicationContext( ).getSystemService( Context.NOTIFICATION_SERVICE );
		notificationManager.cancel( 1 );
	}

	@Override
	public void onReceive(Context context, Intent intent) {
		
		NotificationCompat.Builder builder = new NotificationCompat.Builder( UnityPlayer.currentActivity );
		builder.setContentTitle( intent.getStringExtra( "title" ) );
		builder.setSmallIcon( context.getResources( ).getIdentifier( "app_icon", "drawable", "alm.sisyphe.temporal") );
		builder.setContentText( intent.getStringExtra( "text" ) );
		builder.setAutoCancel( true );
		builder.setWhen( System.currentTimeMillis( ) );
		Intent notificationIntent = new Intent( context, UnityPlayerNativeActivity.class );
		notificationIntent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_NEW_TASK );
		builder.setContentIntent( PendingIntent.getActivity( context, 0, notificationIntent, 0 ) );

		NotificationManager notificationManager = ( NotificationManager ) context.getSystemService( Context.NOTIFICATION_SERVICE );
		notificationManager.notify( 1, builder.build( ) );
	}
}
